/* globals require: true */
/* globals fs: true */
/* globals makeXML: true */
/* globals $: true */
/* exported communicateDocumentOpened */
var communicateInitialized = false;
var communicatePort = 0;
var nodePath = require('path');
var net = require('net');
var communicatePropertiesName = "adpoint_nativeapp.properties";
var propertiesFileString = "com.ix.shared.system.LocalDirs.dataDir";
var clientID = "";
var client = null;
var ix_pathToXML = null;
var ix_currentOpCode="";
var pix_assetID=0;
var pix_assetLocked="false";

$(function () {
	console.log("communication.js loaded");
});

function communicateImageSaved(newPath, myDocsFolderPath, workFlowOption, sourcePath, resourceID) {
	console.log("communicateImageSaved " + newPath +" "+myDocsFolderPath+" "+workFlowOption+" "+resourceID);
	communicateTellImageSaved (newPath,workFlowOption,sourcePath,resourceID);
}

function communicateTellImageSaved (newPath,workFlowOption,sourcePath,resourceID) {
    console.log ("communicateTellImageSaved "+ newPath +" "+workFlowOption+" "+sourcePath+" "+resourceID);
    //ix_pathToXML = communicateGetPort(path);
    if (clientID=="-1" || clientID=="") clientID="77";
    var requestXmlString = '<request cid="'+clientID+'" application="'+localStorage.ixApplicationName+'" action="save" id="'+resourceID+'" path="'+newPath+'" sourcepath="'+sourcePath+'" saveas="'+workFlowOption+'"/>'+'\r\n\r\n';
	communicateSendIt(requestXmlString, commListen);
}


function communicateDocumentOpened(path,docType) {
	console.log("communicateDocumentOpened " + path);
	try {
		if(communicateInitialized == false) {
			communicateInitialized = true;
			communicateInitialize(path,docType);
		}
		else {
			console.log ("communicateDocumentOpened initialized already");
			if (pix_assetID != 0) communicateTellImageOpen (pix_assetID);
		}
	}
	catch(e) {
		console.log("CommunicateDocumentOpened Exception " + e.message);
	}
}

function communicateInitialize(path,docType) {
   console.log("      communicateInitialize " + path);
    communicatePort = communicateGetPort(path);    // n.b. - this sets up path to xml file we read later for port info
	console.log("     ix_pathToXML  is " + ix_pathToXML);
																//if(communicatePort !== 0) {
	communicateSendInitializeToAdPoint (docType);
																//}
}

function communicateGetPort(path) {
	console.log("communicateGetPort " + path);
	var portRet = null;
	do {
		var buf = communicateReadAdPointNativeAppProperties(path);
		if(buf == null) {
		    var errMsg ="Error: ADPOINT properties file is missing. Quit and restart both ADPOINT and Photoshop.";
		    try {
		    	doScript ('pix.wr', nada, errMsg);
		    }catch(e){};
		    console.log (errMsg);
			break;
		}
		ix_pathToXML = communicateGetPathToAdPointNativeAppXML(buf);
		if(ix_pathToXML == null) {
			break;
		}
		
		//doScript('pix.setValue',nada, 'pathToXML', ix_pathToXML );
		
		portRet = communicateGetPortFromXML(ix_pathToXML);
	} while(false);
	return portRet;
}

function communicateReadAdPointNativeAppProperties(path) {
	//console.log("communicateReadAdPointNativeAppProperties " + path);
	var bufRet = null;
	do {
		var propPath = communicateGetPropertiesPath(path);
		if(propPath == null) {
			break;
		}
		bufRet = communicateReadPropertiesFile(propPath);
	} while(false);
	return bufRet;
}

function communicateGetPropertiesPath(path) {
	//console.log("communicateGetPropertiesPath " + path);
	var pathRet = null;
	// the path is two levels up
	var up1 = nodePath.dirname(path);
	console.log("communicateGetPropertiesPath up1 " + up1);
	var up2 = nodePath.dirname(up1);
	console.log("communicateGetPropertiesPath up2 " + up2);
	//var up3 = nodePath.dirname(up2);
	//console.log("communicateGetPropertiesPath up3 " + up3);
	pathRet = nodePath.join(up2, communicatePropertiesName);
console.log("communicateGetPropertiesPath pathRet " + pathRet);
	return pathRet;
}

function communicateReadPropertiesFile(path) {
	//console.log("communicateReadPropertiesFile " + path);
	var buf = null;
	try {
		buf = fs.readFileSync(path, 'utf8');
	}
	catch(e) {
		console.log("communicateReadPropertiesFile exception " + e.message);
	}
console.log("communicateReadPropertiesFile read " + buf);
	return buf;
}

function communicateGetPathToAdPointNativeAppXML(buf) {
	//console.log("communicateGetPathToAdPointNativeAppXML " + buf);
	var path = null;
	var arr = buf.split("\r");
	//console.log("communicateGetPathToAdPointNativeAppXML " + arr.length + " lines");
	
	for(var i = 0; i< arr.length; i++) {
		if(arr[i].indexOf(propertiesFileString) !== -1) {
			path = arr[i].substr(propertiesFileString.length + 1);
			break;
		}
	}
	
	//console.log("communicateGetPathToAdPointNativeAppXML path " + path);
	
	return path;
}

function communicateGetPortFromXML(path) {
	console.log("communicateGetPortFromXML path " + path);
	var portRet = null;
	try {
		do {
			var buf = fs.readFileSync(path, 'utf8');
			//console.log("communicateGetPortFromXML buf " + buf);
			var xmlBuf = makeXML(buf);
			if(xmlBuf == null) {
				break;
			}
			portRet = xmlBuf.find("adpoint").find("plugin").attr("port");
		} while(false);
	}
	catch(e) {
		console.log("communicateGetPortFromXML exception " + e.message);
	}
	return portRet;
}

function communicateSendInitializeToAdPoint(docType) {
    if (docType=="PlanPoint" || docType=="AdPoint") {
    	var initializeData = "<request cid='-1' application='"+localStorage.ixApplicationName+"' action='initialize'></request>\r\n\r\n";
		console.log("communicateSendInitializeToAdPoint "+initializeData);
		communicateSendIt(initializeData, communicateDidInitialize);
    } else {
    	console.log(" communicateSendInitializeToAdPoint error unknown comm init "+docType);
    }
}

function communicateDidInitialize(data) {
	var retString = data.toString();
	console.log("communicateDidInitialize " + retString);
	var xmlBuf = makeXML(retString);
	if(xmlBuf !== null) {
		clientID = xmlBuf.find("response").attr("cid");
		console.log("communicateDidInitialize client id: " + clientID);
		communicateTellImageOpen(pix_assetID);

	}
	else {
		console.log("communicateDidInitialize invalid return cannot make clientID");
	}
	
}

function communicateExport(path) {

    if (path==false) {
         console.log("communicateExport - xml making error");
         return;
    }
    
													//var arr = paths.split("$");
	var xmlPath = path;  							//arr[0] + arr[1];
													//var docPath = arr[0] + arr[2];
													//var changedName = xmlPath.replace("exported", "saved");
	var buf = fs.readFileSync(xmlPath, 'utf8');
													//var res = buf.replace("<resource", "<request cid ='" + clientID + "' action='save' pdfpath='"+arr[3]+"' path='" + docPath + "'");
													//var res2 = res.replace("/resource", "/request");
	buf = buf + "\r\n\r\n\r\n"
													//var res3 = res2;
													//var res3 = res2.replace(/"/g, "'");
													//fs.writeFileSync(changedName, res2, 'utf8');
													//fs.unlinkSync(xmlPath); // delete _exported xml file
													//console.log("communicateExport file written to " + changedName);
													//communicateSendIt(res3, communicateDidExport);
	communicateSendIt(buf, commListen);
}

													//function communicateDidExport(result) {
													//	console.log("communicateDidExport result: " + result.toString());
													//}

function communicateSendIt(buf, dataRoutine) {
    var res ="0";
	myDataRoutine = dataRoutine;
	if(client !== null) {
	
	   try {
	     client.end();
	   } catch (e) {
	     console.log("client.end exception " + e);
	     client=null;
	   }
	
		//res = client.write(buf);
		//console.log("already connected sending " + buf+' res='+res);
		//doScript("pix.wrEscape",nada,"communicateSendIt - already connected port="+communicatePort+" sending " + escape(buf) +" res="+res); // write to jsx log as well
	}
	/*else*/
	 
	
	    communicatePort = communicateGetPortFromXML(ix_pathToXML);  // always look up port pre-connect
	    
	    if (communicatePort==null) {
	       console.log("Unable to find comm port. "+ix_pathToXML);
	       try {
	           doScript('pix.wr',nada,'Unable to find comm port. ' + ix_pathToXML); 
	       }catch(e){};

	       return;
	    }
	    
		client = new net.Socket();
		
		client.connect(communicatePort, '127.0.0.1', function() {
			res = client.write(buf);
			console.log('communicateSendIt port='+communicatePort+' sending ' + buf+' res='+res);
						//console.log('communicateSendIt port='+communicatePort+'" sending ' + buf+' res='+res);
			try {
			   doScript("pix.wrEscape",nada,"communicateSendIt port="+communicatePort+" sending " + escape(buf) +" res="+res); // write to jsx log as well
			}catch(e){};

		});
	
		
		client.on('data', function(data) {
			console.log('communicateSendIt received: ' + data);
			try {
				doScript('pix.wr',nada,'communicateSendIt received: ' + ''); // write to jsx log as well
			}catch(e){};

			if (data !="") myDataRoutine(data);
		});
		
		client.on('close', function(data) {
			console.log('communicateSendIt connection closed');
			//try {
			  //doScript('pix.wr',nada,'communicateSendIt connection closed'); // write to jsx log as well
			//}catch(e){};

			client = null;
		});
		
		client.on('error', function(err) {
			console.log('communicateSendIt error: ' + err);   // if planpoint quit -> error: Error: connect ECONNREFUSED
			try {
				doScript('pix.wr',nada,'JS communicateSendIt error: ' + err);  // write to jsx log as well
			}catch(e){};

		});
		
		client.on('timeout', function(err) {
			console.log(' !!  communicateSendIt timeout error: ' + err);
			try {
				doScript('pix.wr',nada,'JS communicateSendIt timeout error: ' + err);  // write to jsx log as well
			}catch(e){};

			client.end();
		});
	/*}*/
}

function commListen (rtnData) {
	var parent = "";
	var action = "";
	var error  = "";

    console.log("    commListen gets "+rtnData);
    
    if (rtnData =="") {
    	console.log("    commListen got no data");
    	return;
    }

	var xmlData = makeXML(rtnData.toString());
	if(xmlData == null) {
	     console.log("    commListen failed to make XML from "+rtnData.toString()+".");
		return false;
	}
	
	try {
		action = xmlData.find("response").attr("action");  
    } catch (e) {
		console.log ("    commListen no action attrib "+e);
		
	}	
	
	console.log("commListen action "+action);
	
	if (action==undefined) {
	   debugger;
	}
	

    if (action=="initialize"){
   		console.log("   commListen initialize msg");
	} else if (action=="open"){
   		console.log("   commListen open msg");
	} else if (action=="save" ) {
	    console.log("   commListen save msg");
	     tell_UI("closeDialog$");
	 } else {
	    console.log("    commListen unmatched action "+action);
	}
	 
	 return;
}

function closedTheDoc (parentDocId) {
   console.log ("closedTheDoc "+parentDocId);
   if (parentDocId != "") {
     var closedFileMessage = '<request cid="'+clientID+'" application="'+localStorage.ixApplicationName+'" action="close" parent="'+parentDocId+'"></request>\r\n\r\n';
     communicateSendIt(closedFileMessage, commListen);
   }
}



function communicateTellImageOpen (assetID) {
    console.log ("communicateTellImageOpen "+assetID);
    //ix_pathToXML = communicateGetPort(path);
    if (clientID=="-1" || clientID=="") clientID="77";
    var requestXmlString = '<request cid="'+clientID+'" application="'+localStorage.ixApplicationName+'" action="open" id="'+assetID+'"/>'+'\r\n\r\n';
	communicateSendIt(requestXmlString, commListen);
}

function communicateTellADOpen (parentStr, nameStr) {
    console.log ("communicateTellADOpen "+parentStr+" "+nameStr);
    var requestXmlString = '<request cid="'+clientID+'" application="'+localStorage.ixApplicationName+'" action="open" name="'+nameStr+'" parent="'+parentStr+'" />'+'\r\n\r\n';
	communicateSendIt(requestXmlString, commListen);
}

/*
function communicateTellPPOpen (openedPageList) {
    console.log ("communicateTellPPOpen "+openedPageList);
    if (openedPageList=="") return;
    var aTmp=[];
    var aTmp = openedPageList.split(delim);
      
    var requestXmlString = '<request cid="'+clientID+'" application="'+localStorage.ixApplicationName+'" action="open" />';
    
	var xmlData = makeXML(requestXmlString.toString());
	if(xmlData == null) {
		 console.log("    communicateTellPPOpen failed to make XML from "+requestXmlString);
		return false;
	}

	for (var i=0; i<aTmp.length; i++) {
		xmlData.find("request").append('<page parent="'+stripDownToNumber(aTmp[i])+'" />');
	}
	var xmlString = (new XMLSerializer()).serializeToString(xmlData[0]);

	var openedFileMessage = xmlString+'\r\n\r\n';

	console.log("communicateTellPPOpen data to send to PlanPoint: "+xmlString);
 
	communicateSendIt(openedFileMessage, commListen);
}
*/
		
function stripDownToNumber (str) {
	if (str.indexOf('.')<0) return str;
	var aTmp=[];
	aTmp = str.split('.')

    return (aTmp[aTmp.length-1]);

}